/*
    FEARLUS model0-7: SelectUseBucket.h
    Copyright (C) 1999-2003  Macaulay Institute

    This file is part of FEARLUS model0-7, an agent-based model of land use
    change.

    FEARLUS model0-7 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-7 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


Interface for the SelectUseBucket object. This object creates buckets for
selecting land uses. It enables the buckets to be accessed by LandUse, or by
index in the environment's landUses array. It can choose at random from the
buckets.

*/

#import <objectbase/SwarmObject.h>
#import <random.h>
@class Parameter, LandUse, Interval;

@interface SelectUseBucket: SwarmObject {
  id landUses;			// array of land uses
  Parameter *parameter;		// set of parameters
}

+create: aZone withParameters: (Parameter *)p andLandUses: lu;
-(void)addScore: (Interval *)s toBucketForLandUse: (LandUse *)lu;
-(void)addAverageScore: (Interval *)s toBucketForLandUse: (LandUse *)lu;
-(Interval *)getScoreInBucketOfLandUse: (LandUse *)lu;
-(void)setScore: (Interval *)s inBucketForLandUse: (LandUse *)lu;
-(LandUse *)getChoice;
-(LandUse *)getDeterministicOptimumChoice;
-(LandUse *)getRandomOptimumChoice;

@end
